//+------------------------------------------------------------------+
//|                                                      FullSSA.mq4 |
//|                                           Copyright  2007, klot |
//|                                                     klot@mail.ru |
//|                                   "" : frantsuz |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, klot"
#property link      "klot@mail.ru"

//----  

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 FireBrick
#property indicator_level1 0.0

//----  :

int  MaxCompCol=20; //     
int  MaxCatLag=200; //   
int  MaxLen=5000; //    

//----  :

extern int NumComps=5; //    
extern int Lag=6; //  
extern int N=300; //   

//----  :

double arryTimeSeries[]; //  
double temp[]; //  (?)

//----  :
double SSA[];

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int init()
  {
//----   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SSA);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
int start()
  {
//---- ""    ...
   ArrayResize(arryTimeSeries,N);
   for(int i=N-1; i>=0; i--) arryTimeSeries[i]=Close[i];
   
//   Lag=Period(); //?
//---- ...      
   fastsingular(arryTimeSeries,N,Lag,NumComps,SSA);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| ()  2  1                    |
//+------------------------------------------------------------------+
void Equal(double &x1[][], double x2[][], int t=0)
{
 int N=ArrayRange(x1,0); // 
 int M=ArrayRange(x1,1); // 
 
 for(int i=0;i<N;i++)
  {
   for(int j=0;j<M;j++)
     {
      if(t!=0) x1[i][j]=x2[j][i]; //
      else x1[i][j]=x2[i][j]; //
     } 
  }
}
//+------------------------------------------------------------------+
//|                                                                   |
//+------------------------------------------------------------------+
double gaussSn(double A[][], double l, int n)
{
   int count,i1,i,j,k;
   double B[200][200]; //  
   double c;
   double w[]; ArrayResize(w,n);

//----     ,
//      
//
   Equal(B,A);
   for (i=0;i<n;i++) B[i][i] = B[i][i]-l;
//----     ?  
   for(k=0;k<n-1;k++)
     {
      for(i=k+1;i<n;i++)
        {
         if(B[k,k]==0)
           {
//----       ?
            for(i1=0;i1<n;i1++)
              {
               w[i1] = B[i1][k];
               B[i1][k] = B[i1][k+1];
               B[i1][k+1] = w[i1];
              }
           }
         
         c=B[i][k]/B[k][k];
         for(j=0;j<n;j++) B[i][j] = B[i][j]-B[k][j]*c;
        }
     }
     
//----      
   count=0;   
   for(i=0;i<n;i++) if(B[i][i]<0) count++;
//----     
   return (1.0*count);
}
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
double gaussbisectionl(double& A[][], int k, int n)
{
	double e1,maxnorm,cn,a1,b1,c;
	int i,j;
//----      
	maxnorm = 0;
	for (i=0;i<n;i++)
	  {
		cn = 0;
		for(j=0;j<n;j++) cn = cn+A[i][j];
		if (maxnorm<cn) maxnorm=cn;
	  }
//----       	  

	a1=0; //  ""
	b1=10 * maxnorm; //  ""
	e1=1.0 * maxnorm /10000000;  //  
	                             //(,  )
	while(MathAbs(b1-a1)>e1)     //
	  {
		c = 1.0*(a1+b1)/2; // ""
		if (gaussSn(A,c,n)<k) a1=c;
		else                  b1=c;
	  }
//----  	  
 return ((a1+b1)/2.0);
}
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
void svector(double& A[][], double l, int n, double& V[])
{ 
   int i1,i,j,k;
	double B[200][200];
	double c;
	double w[]; ArrayResize(w,n);

//----     ,
//      
//
	
	Equal(B,A);
	for(i=0;i<n;i++)  B[i][i]=B[i][i]-l;

//----       	
	for(k=0;k<n-1;k++)
	  for(i=k+1;i<n;i++)
	    {
	     if(B[k][k]==0)
			  {
				for(i1=0;i<n;i++)
				  {
					w[i1]=B[i1][k];
					B[i1][k]=B[i1][k+1];
					B[i1][k+1]=w[i1];
				  }
			   }
			c=B[i][k]/B[k][k];
			for (j=0;j<n;j++) B[i][j]=B[i][j]-B[k][j]*c;
		 }
//----  	
	V[n-1]=1;
	c=1;
	for(i=n-2;i>=0;i--)
	  {
		V[i]=0;
		for(j=i;j<n;j++) V[i]= V[i]-B[i][j]*V[j];
		V[i]=V[i]/B[i][i];
		c+=V[i]*V[i];
	  }
	for (i=0;i<n;i++)	V[i]= V[i]/MathSqrt(c);
}
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void fastsingular(double X[], int n, int l, int s, double& Y[])
//---- X[] -   , n -  , l - 
//, s -     ,     
//Y[] -   
{
   if(s>MaxCompCol) s=MaxCompCol;
	if(l>MaxCatLag) l=MaxCatLag; // 
   if(n>MaxLen) n=MaxLen;
   if(s>l) s=l; //  
   
	
	double A[200][200]; //  
	double B[5000][200]; //  
	double Bn[200][5000];
	
	int kb,lb,m,k,i,j,i1;
	double V[200][5000]; //   
	double Yn[200][5000]; 
	double ls[200]; //  
	
	double Vtemp[200]; 

//----     
//  

	k=n-l+1; //   
	
	for (i=0;i<l;i++)
     {
	   for (j=0;j<l;j++)
        {
		   A[i][j]=0;
		   for (m=0;m<k;m++)
		     {
				A[i][j]=A[i][j]+X[i+m]*X[m+j];
				B[m][j]=X[m+j];
			  }
		  }
     }

//----  ,      
//   .   

	for (i=0;i<s;i++)
     {
      ls[i]=gaussbisectionl(A,l-i,l); //   
      svector(A,ls[i],l,Vtemp); //  
      for(j=0;j<l;j++) V[i][j]=Vtemp[j];
     }

//---- 

	for (i1=0;i1<s;i1++)
     {
     
//----  Bn = T(V)*B*V (T - )
		for (i=0;i<k;i++)
		  {
			Yn[i1][i]=0;
			for (j=0;j<l;j++) Yn[i1][i]=Yn[i1][i]+B[i][j]*V[i1][j];
		  } 
		for (i=0;i<l;i++)
		  {
			for (j=0;j<k;j++)	Bn[i][j]=Yn[i1][j]*V[i1][i]; 
		  }

//----   
		
		kb=k;
		lb=l;
		
		for (i=0;i<n;i++)
		  {
			Yn[i1][i]=0;
			if (i<lb-1)
			  {
				for (j=0;j<=i;j++)
				  {
					if (l<=k) Yn[i1][i] = Yn[i1][i]+Bn[j][i-j];
					if (l>k)  Yn[i1][i] = Yn[i1][i]+Bn[i-j][j];
				  }
				Yn[i1][i] = Yn[i1][i]/(1.0*(i+1));
			  }
			if ((lb-1<=i)&&(i<kb-1))
			  {
				for (j=0;j<=lb-1;j++)
				  {
					if (l<=k) Yn[i1][i]=Yn[i1][i]+Bn[j][i-j];
					if (l>k) Yn[i1][i]=Yn[i1][i]+Bn[i-j][j];
				  }
				Yn[i1][i] = Yn[i1][i]/(1.0*lb);
			  }
			if (kb-1<=i)
			  {
				for (j=i-kb+1;j<=n-kb;j++)
				  {
					if (l<=k) Yn[i1][i]=Yn[i1][i]+Bn[j][i-j];
					if (l>k) Yn[i1][i]=Yn[i1][i]+Bn[i-j][j];
				  }
				Yn[i1][i] = Yn[i1][i]/(1.0*(n-i));
			  }
		  }
      }

//----   

	for (i=0;i<=n-1;i++)
     {
		Y[i]=0;
		for (i1=0;i1<s;i1++)  Y[i]=Y[i]+Yn[i1][i];
     }
}